<template>
    <div>
        <breadcrumb-component title="Fornecedores" :pages="breadPages"/>

        <panel-component title="Listar Fornecedores">

            <div class="form-search">
                <div class="form-group col-md-6">
                    <router-link class="btn btn-primary" :to="{name: 'providers.create'}">
                        <i class="fa fa-plus-circle"></i> Cadastrar Fornecedor
                    </router-link>
                </div>

                <div class="form-group col-md-6 form-inline text-right">
                    <div class="input-group">
                        <input type="text" placeholder="Pesquisar por nome" class="form-control"
                               v-model="formSearch.name"/>
                        <span class="input-group-btn">
                            <button type="button" class="btn btn-primary" @click.prevent="loadProviders(1)" >
                                 <i class="fa fa-search"></i>
                            </button>
                        </span>
                    </div>
                    <button type="button" class="btn btn-white" @click.prevent="isFormSearch = !isFormSearch">
                        <i class="fa fa-search-plus"></i> Busca avançada
                    </button>
                </div>
            </div>

            <div class="col-md-12 label-form" v-if="isFormSearch">
                <div class="form-group col-md-2">
                    <label>Tipo de pessoa</label>
                    <select class="form-control" v-model="formSearch.tipo">
                        <option value="">--Selecione--</option>
                        <option value="fisica">Pessoa Física</option>
                        <option value="juridica">Pessoa Jurídica</option>
                        <option value="estrangeiro">Estrangeiro</option>
                    </select>
                </div>

                <div class="form-group col-md-4">
                    <label>Nome / Razão social</label>
                    <input type="text" class="form-control" v-model="formSearch.name"/>
                </div>


                <div class="form-group col-md-3">
                    <label>Telefone / Celular</label>
                    <input type="text" class="form-control" placeholder="Ex: (xx)xxxxx-xxxx"
                           v-model="formSearch.telefone"/>
                </div>

                <div class="form-group col-md-3">
                    <label>E-mail</label>
                    <input type="text" class="form-control" v-model="formSearch.email"/>
                </div>


                <div class="form-group col-md-3">
                    <label>Cidade</label>
                    <input type="text" class="form-control" v-model="formSearch.cidade"
                           placeholder="Ex: Belo Horizonte"/>
                </div>

                <div class="form-group col-md-2">
                    <label>UF</label>
                    <input type="text" class="form-control" placeholder="Ex: MG" v-model="formSearch.uf"/>
                </div>

                <div class="form-group col-md-3">
                    <label v-if="formSearch.tipo == 'fisica'">CPF</label>
                    <label v-if="formSearch.tipo == 'juridica'">CNPJ</label>
                    <label v-if="formSearch.tipo == 'estrangeiro'">Documento</label>
                    <input-mask type="text" class="form-control" mask="11.111.111/1111-11"
                                v-if="formSearch.tipo == 'juridica'" v-model="formSearch.cnpj"/>
                    <input-mask type="text" class="form-control" mask="111.111.111-11"
                                v-if="formSearch.tipo == 'fisica'" v-model="formSearch.cpf"/>
                    <input type="text" class="form-control" v-model="formSearch.documento"
                           v-if="formSearch.tipo == 'estrangeiro'"/>
                </div>

                <div class="form-group col-md-12">
                    <button class="btn btn-primary" @click.prevent="loadProviders(1)">
                        <i class="fa fa-search"></i> Buscar
                    </button>
                    <button class="btn btn-white" @click.prevent="isFormSearch = false">
                        <i class="fa fa-remove"></i> Fechar
                    </button>
                </div>
            </div>


            <div class="table-responsive col-md-12">
                <table class="table table-striped table-hover table-bordered">
                    <thead>
                    <tr>
                        <th>Nome</th>
                        <th>Tipo</th>
                        <th>Telefone</th>
                        <th>Celular</th>
                        <th>Email</th>
                        <th>Cadastrado em</th>
                        <th class="text-center" style="width: 130px">Ação</th>
                    </tr>
                    </thead>
                    <tbody>
                    <tr v-for="provider in providers.data" :key="provider.id">
                        <td>{{provider.name}}</td>
                        <td>{{provider.tipo | typePerson}}</td>
                        <td>{{provider.telefone}}</td>
                        <td>{{provider.celular}}</td>
                        <td>{{provider.email}}</td>
                        <td>{{provider.created_at | dateFormat}}</td>
                        <td class="text-center">
                            <router-link
                                    :to="{name: 'providers.detail', params: {id: provider.id}}"
                                    class="btn btn-xs btn-white">
                                <i class="fa fa-eye"></i>
                            </router-link>
                            <router-link
                                    :to="{name: 'providers.edit', params: {id: provider.id}}"
                                    class="btn btn-xs btn-info ">
                                <i class="fa fa-pencil"></i>
                            </router-link>
                            <button class="btn btn-xs btn-danger" @click.prevent="confirmDestroy(provider)">
                                <i class="fa fa-remove"></i>
                            </button>
                        </td>
                    </tr>
                    </tbody>
                </table>
                <p>Mostrando: {{providers.data.length}} de um total de: {{providers.total}} registros.</p>
                <pagination
                        :data="providers"
                        :limit="1"
                        @pagination-change-page="loadProviders">
                    <span slot="prev-nav">Anterior</span>
                    <span slot="next-nav">Próximo</span>
                </pagination>
            </div>
        </panel-component>

    </div>
</template>

<script>
    export default {
        data() {
            return {
                formSearch: {
                    tipo: '',
                    cpf: '',
                    cnpj: '',
                    documento: '',
                    name: '',
                    email: '',
                    telefone: '',
                    cidade: '',
                    uf: '',
                },
                isFormSearch: false,
                breadPages: [
                    {link: 'dashboard', name: 'Dashboard', active: false},
                    {link: 'providers', name: 'Fornecedores', active: false},
                    {link: 'providers', name: 'Listar', active: true},
                ]
            }
        },

        created() {
            this.loadProviders(1)
        },

        computed: {
            providers() {
                return this.$store.state.providers.items
            },
            params() {
                return {
                    page: this.providers.current_page,
                    tipo: this.formSearch.tipo,
                    cnpj: this.formSearch.cnpj,
                    cpf: this.formSearch.cpf,
                    documento: this.formSearch.documento,
                    name: this.formSearch.name,
                    email: this.formSearch.email,
                    telefone: this.formSearch.telefone,
                    cidade: this.formSearch.cidade,
                    uf: this.formSearch.uf,
                }
            }
        },

        methods: {
            loadProviders(page) {
                this.$store.dispatch('loadProviders', {...this.params, page})
            },
            confirmDestroy(provider) {
                this.$snotify.confirm(`Deseja realmente apagar o fornecedor: ${provider.name} ?`, 'Deletar ?', {
                    timeout: 5000,
                    showProgressBar: true,
                    closeOnClick: false,
                    pauseOnHover: true,
                    buttons: [
                        {
                            text: 'Sim', action: (toast) => {
                            this.$snotify.remove(toast.id)
                            this.destroyProvider(provider.id)
                        }
                        },
                        {
                            text: 'Não', action: (toast) => {
                            console.log('Clicked: No');
                            this.$snotify.remove(toast.id)
                        }
                        },
                    ]
                })
            },

            destroyProvider(id) {
                this.$store.dispatch('destroyProvider', id)
                    .then(() => {
                        this.loadProviders(1)
                        this.$snotify.success('fornecedor apagado com sucesso!', 'Sucesso')
                    })
                    .catch(() => {
                        this.$snotify.error('Não foi possível apagar o fornecedor!', 'Error')
                    })
            }
        }
    }
</script>